package com.example.demo.supply.Supplier;

import com.example.demo.supply.Order._Order;
import com.example.demo.supply.Product.Product;
import com.fasterxml.jackson.annotation.JsonIgnore;
import jakarta.persistence.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Entity
public class Supplier {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false)
    private String name;
    @Column(nullable = false)
    private int license;

    @JsonIgnore
    @OneToMany(fetch = FetchType.EAGER, mappedBy = "supplier",  cascade = CascadeType.REMOVE)
    private List<_Order> orders;

    public Supplier(){}

    public Supplier( String name, int license) {
        this.name = name;
        this.license = license;
        orders = new ArrayList<>();
    }

    public Long getId() { return id; }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getLicense() {
        return license;
    }

    public void setLicense(int license) {
        this.license = license;
    }

    public List<_Order> getOrders() {
        return orders;
    }

    public void setOrders(List<_Order> orders) {
        this.orders = orders;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Supplier supplier = (Supplier) o;
        return Objects.equals(id, supplier.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    @Override
    public String toString() {
        return "Product{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", license='" + license + '\'' +
                '}';
    }
}
